/*
距離計
・現在の速度値を提供する。
・現在の速度値を提供する。
2014/07/14    by S.Ushimaru
*/
#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/io.h>
#include "hardware.h"
#include "encoder.h"
#include "distance.h"

static float dis_coef = 2*3.1415*TIRE_R/ENC_PPS/M_E_RATIO; //for STANDARD MIRS

void distance_get(struct distance_data *distance_data){

	struct encoder_data encoder_data;

	encoder_get(&encoder_data);

	distance_data->left = encoder_data.left_sum * dis_coef * TIRE_DIST_RATIO ;
	distance_data->right = encoder_data.right_sum * dis_coef;

	//printf("distance_l =%6.1f     distance_r=%6.1f\n",distance_data->left, distance_data->right);

	return;

}


void distance_reset(){

	encoder_reset();
	return;

}

