// patrol.c
//大場　1214 作成
#include <stdio.h>
#include <linux/errno.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <sys/io.h>

//test_ioより
#include <sys/ioctl.h>
#include <string.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "device.h"
#include "io.h"
#include "hardware.h"
#include "direction.h"
#include "vel_ctrl.h"
#include "run_ctrl.h"
#include "sequence.h"

#define PATROL_RUN 0//直進処理
#define PATROL_TURN 1//回転処理
#define PATROL_DIRECTION 2//正体補正
#define PATROL_IO 3//io_ioチェック
#define PATROL_RED 4//red_ioチェック

#define PATROL_RUNDIST 340 //直線走行距離[cm]
#define PATROL_IO5RUNDIST -35//IO5が反応したときの直線走行距離（後退）[cm]
#define PATROL_TURNDIST -90 //回転角度[deg]
#define PATROL_IO4TURNDIST -30//IO4（左）が反応したときの回転角度[deg]
#define PATROL_IO6TURNDIST 30//IO6（右）が反応したときの回転角度[deg]


int patrol(void){
	printf("patrol_start!\n");
	float default_speed = 130.0; //直進速度[cm/sec] 
	float default_speed_rot = -90.0; //回転速度 [deg/sec]
//	int face_distance = 50; //正体補正する距離
	char io_mdata[12];//io反応を格納
//	int prun_distance_c=0/*直進の次が正体補正か回転か*/;
	int ptrack=0/*これが1になればbreak*/;
//	int pt=0/*タッチ反応確認*/,pr=0/*赤外線反応確認*/,i/*ループまわす*/=0;
	int now_do=PATROL_RUN;//はじめは直進処理から
	int maa;
//----------------------------------------------------------
	printf("kotaetekudasai!!!!!!!!!!!=");
	scanf("%d",&maa);
	switch (maa){
		case 0:		
				run_ctrl_set(0,130);
				run_ctrl_set_dist((float)-15);
				run_ctrl_create();
				while(1){
					if(run_ctrl_get_endflag()==1)break;
				}
				run_ctrl_cancel();	
//sequenceから、90d度回転
				//run_ctrlに値を入れる
				run_ctrl_set(1,default_speed_rot); 
				run_ctrl_set_dist((float)-90);
				run_ctrl_create();

				// endflag が 1 になるまで loop する
				while(1){
					if(run_ctrl_get_endflag()==1) break;//whileを抜ける
				}
				run_ctrl_cancel();

//----------------------------------------------------------
//sequenceから、90d度回転
				//run_ctrlに値を入れる
				run_ctrl_set(PATROL_RUN,default_speed); 
				run_ctrl_set_dist((float)40);
				run_ctrl_create();

				// endflag が 1 になるまで loop する
				while(1){
					if(run_ctrl_get_endflag()==1) break;//whileを抜ける
				}
				run_ctrl_cancel();


		
		case 1:
	
//------------------------------------------------------------
//------------------------------------------------------------

	while(1){
		switch (now_do){//現在のすること
//-------------------------------------------------------------
			case PATROL_RUN://直進処理
				printf("PATROL_RUN\n");
//				prun_distance_c++;//何回目の直進か

				//run_ctrlに値を入れる
				run_ctrl_set(PATROL_RUN,default_speed); 
				run_ctrl_set_dist((float)PATROL_RUNDIST);
				run_ctrl_create();

				// endflag が 1 になるまで loop する
				while(1){
					if(run_ctrl_get_endflag()==1) break;//whileを抜ける
					io_get(io_mdata);//ioデータを見る
//					pt=0;
//					pr=0;
//		     		for(i=0;i<12;i++){
//						if(i<4)	pr=pr+(int)io_mdata[i];
//						if(3<i<8) pt=pt+(int)io_mdata[i];
//					}
					printf("A_get_io!\n");
//					if(pr/*<3*/>0 || pt/*<3*/>0) break;		
					usleep(2000);
				}
//				if(pr/*<3*/>0) now_do=PATROL_RED;
//				if(pt/*<3*/>0) now_do=PATROL_IO;//io優先
//				if(run_ctrl_get_endflag()==1){
//					if(prun_distance_c%2==1){
						now_do=PATROL_TURN;//奇数：回転
//					}else{
//						now_do=PATROL_DIRECTION;//偶数：補正
//					}
//				}
				run_ctrl_cancel();
				break;

//-----------------------------------------------------------
			case PATROL_TURN://回転処理
				printf("PATROL_TURN\n");

				run_ctrl_set(PATROL_TURN,default_speed_rot); 
				run_ctrl_set_dist((float)PATROL_TURNDIST);
				run_ctrl_create();

				// endflag が 1 になるまで loop する
				while(1){
					if(run_ctrl_get_endflag()==1) break;
					io_get(io_mdata);//io監視
					printf("B_get_io!\n");				
//					pr=0;
//		     			for(i=0;i<12;i++){
//					if(i<4)	pr=pr+(int)io_mdata[i];
//					if(3<i<8) pt=pt+(int)io_mdata[i];
//					}
//					if(pr/*<3*/>0) break;
					 usleep(20000);
				}
//				if(pr/*<3*/>0) now_do=PATROL_RED;//反応があれば赤外線反応へ
				if(run_ctrl_get_endflag()==1) now_do=PATROL_RUN;//次は直進
				run_ctrl_cancel();
				break;

//--------------------------------------------------------------
/*
			case PATROL_DIRECTION://正体補正
				printf("PATROL_DIRECTION\n");
				direction_correct(face_distance);
				now_do=PATROL_TURN;//次は回転
				break;
*/
//-------------------------------------------------------------
/*
			case PATROL_IO://io反応処理
				printf("PATROL_IO\n");
				io_get(io_mdata);
				if(io_mdata[1]==1||io_mdata[3]==1){//左右が反応したら
					if((int)io_mdata[1]==1)run_ctrl_set(PATROL_TURN,-default_speed_rot);
					if((int)io_mdata[1]==1)run_ctrl_set_dist((float)PATROL_IO4TURNDIST);
					if((int)io_mdata[3]==1)run_ctrl_set(PATROL_TURN,default_speed_rot);
					if((int)io_mdata[3]==1)run_ctrl_set_dist((float)PATROL_IO6TURNDIST);
					run_ctrl_create();
				}else{//前面が反応したら
					run_ctrl_set(PATROL_RUN,default_speed);
					run_ctrl_set_dist((float)PATROL_IO5RUNDIST);
					run_ctrl_create();
				}

				// endflag が 1 になるまで loop する
				while(1){
					if(run_ctrl_get_endflag()==1) break;
					 usleep(20000);
				}
				run_ctrl_cancel();

				direction_correct(face_distance);//正体補正
				
				//90度回転
				run_ctrl_set(PATROL_TURN,default_speed_rot);
				run_ctrl_set_dist((float)PATROL_TURNDIST);
				run_ctrl_create();

				// endflag が 1 になるまで loop する
				while(1){
					if(run_ctrl_get_endflag()==1) break;
					 usleep(20000);
				}
				run_ctrl_cancel();
				now_do=PATROL_RUN;//次は直進
				break;
*/
//-------------------------------------------------------------
/*
			case PATROL_RED://赤外線反応処理
				printf("PATROL_RED");
				ptrack=1;
				break;
*/
//-----------------------------------------------------------

			default:
				printf("Go straight!");
				now_do=PATROL_RUN;//何もなければ直進からスタート
		}//case end

	if(ptrack==1)break;
	printf("ptrack=%d",ptrack);
	}//while end
	}
	printf("END_patrol!");
	return 2;
}
